#include <assert.h>
#include <langinfo.h>
#include <locale.h>
#include <nl_types.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(void)
{
	char *codeset, *saved_codeset;
	char *previous_lc_ctype;

	/* Save the currently set LC_TYPE value to restore it later. */
	previous_lc_ctype = strdup(setlocale(LC_CTYPE, NULL));

	printf("Initial LC_TYPE value '%s'\n", previous_lc_ctype);

	/* Tell setlocale() to search all user environment variables. */
	setlocale(LC_CTYPE, "");
	/* Query now those values. */
	codeset = nl_langinfo(CODESET);
	/* If there is a string, store it, otherwise get a fake string. */
	if (codeset && *codeset) {
		saved_codeset = strdup(codeset);
	} else {
		saved_codeset = strdup("unknown");
	}
	/* Finally restore the previous value of the variable. */
	setlocale(LC_CTYPE, previous_lc_ctype);
	free(previous_lc_ctype);

	printf("The codeset is '%s'\n", saved_codeset);
	free(saved_codeset);
	return 0;
}
