#include <assert.h>
#include <allegro.h>
#include <stdio.h>
#include <string.h>

/* Display non-printable characters as escape codes. */
void true_printf(const char *text)
{
	while (*text) {
		if (*text >= 32 && *text <= 126)
			fprintf(stdout, "%c(%d)", *text, *text);
		else
			fprintf(stdout, "\\x%x", *text);

		text++;
	}
}

/* Loads a file and reads a character. Returns false on error. */
int load_file(const char *filename)
{
	int byte;
	PACKFILE *input_file = pack_fopen(filename, "r");

	if (!input_file)
		return 0;

	byte = pack_getc(input_file);
	pack_fclose(input_file);
	return 1;
}

int main(void)
{
	set_uformat(U_ASCII); /* Works for 4.0.x, not for 4.2.0. */
	allegro_init();
	set_color_depth(32);
	/* Set a graphic mode to avoid asserts in debug builds... */
	set_gfx_mode(GFX_SAFE, 320, 200, 0, 0);

	struct al_ffblk info;

	if (al_findfirst("*.c", &info, FA_ALL) != 0) {
		/* Tell user there are no source files. */
		printf("No *.c files?\n");
		return 1;
	}

	do {
		/* Do something useful here with info.name. */
		printf("Loading `%s'\n", info.name);
		if (!load_file(info.name)) {
			printf("Error loading '");
			true_printf(info.name);
			printf("'\n");
		}
	} while (al_findnext(&info) == 0);

	al_findclose(&info);
	printf("End of program\n");

	return 0;
}
END_OF_MAIN()
